#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "fire500three4xi.py">
#<abstract4xi abstract = "fires to direction three and to distance 500"/>
#<verify4xi verification = "11" target = "verb4xi.py"/>
#<refer4xi reference = "verb4xi.py"/>
#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'fire500three4xi']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread   

import signal
import itertools
import weakref
import logging 

from math import pi
from math import sin
from math import cos 
from math import fabs
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "


from time4xi import time4xi

#"
#/>
       
# -------------------------------------------------------------------------------------------------
# SHOT2THREE - COORDINATE SIGNS OF SHOOT2THREE4XI: (X + ,Y + ,Z - )
# -------------------------------------------------------------------------------------------------    
global shot2three5004xi
#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = False

       
# -------------------------------------------------------------------------------------------------
# SHOT2THREE - COORDINATE SIGNS OF SHOOT2THREE4XI: (X + ,Y + ,Z - ) - STUBS ONLY - ALL ARE IN FILES
# -------------------------------------------------------------------------------------------------    

shot2three5004xi = {
                1:'0x117y-485z',
                2:'0x14y-499z',
                3:'0x485y-120z',
                4:'0x4y-499z',
                5:'0x9y-499z',
                6:'101x479y-100z',
                7:'102x142y-468z',
                8:'110x444y-199z',
                9:'112x140y-466z',
                10:'118x413y-254z',
                11:'11x38y-498z',
                12:'121x458y-367z',
                13:'122x137y-464z',
                14:'122x378y-302z',
                15:'127x474y-95z',
                16:'12x126y-483z',
                17:'12x13y-499z',
                18:'132x134y-462z',
                19:'134x440y-195z',
                20:'140x409y-250z',
                21:'143x130y-460z',
                22:'143x374y-298z',
                23:'151x467y-90z',
                24:'153x125y-458z',
                25:'158x434y-190z',
                26:'15x42y-497z',
                27:'15x449y-217z',
                28:'162x403y-246z',
                29:'163x120y-456z',
                30:'163x369y-294z',
                31:'16x16y-499z',
                32:'173x114y-454z',
                33:'176x459y-85z',
                34:'181x427y-185z',
                35:'184x362y-290z',
                36:'184x396y-241z',
                37:'19x130y-482z',
                38:'19x45y-497z',
                39:'1x19y-499z',
                40:'1x2y-499z',
                41:'200x450y-81z',
                42:'204x355y-286z',
                43:'204x418y-181z',
                44:'206x388y-237z',
                45:'20x18y-499z',
                46:'224x346y-282z',
                47:'224x440y-76z',
                48:'226x409y-176z',
                49:'227x379y-233z',
                50:'23x49y-496z',
                51:'243x336y-278z',
                52:'247x428y-71z',
                53:'248x368y-228z',
                54:'248x398y-171z',
                55:'25x20y-498z',
                56:'25x485y-115z',
                57:'262x325y-273z',
                58:'268x357y-224z',
                59:'269x415y-66z',
                60:'270x385y-167z',
                61:'27x134y-480z',
                62:'281x313y-269z',
                63:'288x344y-219z',
                64:'28x52y-496z',
                65:'291x372y-162z',
                66:'291x401y-61z',
                67:'299x300y-265z',
                68:'29x418y-271z',
                69:'307x330y-215z',
                70:'30x21y-498z',
                71:'311x358y-157z',
                72:'312x386y-56z',
                73:'316x285y-261z',
                74:'326x315y-210z',
                75:'330x342y-153z',
                76:'332x270y-256z',
                77:'332x369y-51z',
                78:'33x55y-495z',
                79:'343x299y-206z',
                80:'348x254y-252z',
                81:'349x325y-148z',
                82:'352x352y-46z',
                83:'35x137y-479z',
                84:'360x281y-201z',
                85:'366x307y-143z',
                86:'370x333y-41z',
                87:'376x263y-196z',
                88:'383x289y-138z',
                89:'387x313y-36z',
                90:'399x269y-133z',
                91:'39x450y-213z',
                92:'39x57y-495z',
                93:'3x24y-499z',
                94:'403x293y-31z',
                95:'42x0y-498z',
                96:'44x139y-477z',
                97:'45x59y-494z',
                98:'4x6y-499z',
                99:'50x484y-110z',
                100:'51x419y-267z',
                101:'51x60y-493z',
                102:'53x141y-476z',
                103:'58x61y-492z',
                104:'5x122y-484z',
                105:'5x29y-499z',
                106:'62x143y-474z',
                107:'63x449y-208z',
                108:'65x61y-491z',
                109:'71x61y-491z',
                110:'72x143y-473z',
                111:'73x418y-263z',
                112:'76x482y-105z',
                113:'78x60y-490z',
                114:'7x416y-276z',
                115:'82x144y-471z',
                116:'85x58y-489z',
                117:'87x447y-204z',
                118:'8x10y-499z',
                119:'8x33y-498z',
                120:'92x143y-470z',
                121:'95x416y-259z'}

                
 
# -----------------------------------------------------------------------------------------------------------
#<function4xi function = "fire500three4xi" usage = "target function for chargethree4xi with Process4Xi">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -----------------------------------------------------------------------------------------------------------
def fire500three4xi(queue2three, consumer_channel2three, publisher_channel2three):
    '''
    returns (x,y,z) coordinates via queue
    '''
    
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    if ack2debug is True:
        print("\n (STEP 1A1/33) OF FIRE500THREE4XI - STARTED TIME: ", time2start)
        # 
        
        print("\n (STEP 1A2/33) OF FIRE500THREE4XI -  QUEUE2THREE: ", queue2three)      
        # 
        
        print("\n (STEP 1A3/33) OF FIRE500THREE4XI -  CONSUMER_CHANNEL2THREE: ", consumer_channel2three)
        #  
              
        print("\n (STEP 1A4/33) OF FIRE500THREE4XI -  PUBLISHER_CHANNEL2THREE: ", publisher_channel2three)          
        # 
        


    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # QUEUE RETURNING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ack2put = False
    if ack2debug is True:
        print("\n (STEP 2A/33) OF FIRE500THREE4XI - TRYING TO RETURN BY PUTTING COORDINATE DICTIONARY TO QUEUE2THREE: ", queue2three, " - TIME: ", time4xi()) 
        # 
         
    try:
        # ------------------------------------------------------------------------------------- 
        # PUT SHOT TO QUEUE 
        # -------------------------------------------------------------------------------------                 
        queue2three.put(shot2three5004xi)
        if ack2debug is True:
            print("\n (STEP 2B/33) OF FIRE500THREE4XI - SUCCEEDED TO PUT COORDINATE DICTIONARY TO QUEUE2THREE: ", queue2three, " - TIME: ", time4xi()) 
            # 
             
        ack2put = True
    except:
        print("\n (STEP 2C/33) OF FIRE500THREE4XI *** FAILED TO PUT COORDINATE DICTIONARY TO QUEUE2THREE: ", queue2three, " - TIME: ", time4xi()) 
    
    if ack2debug is True:
        print("\n (STEP 3A/33) OF FIRE500THREE4XI - TRYING TO INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER_CHANNEL2THREE: ", publisher_channel2three, " - TIME: ", time4xi())
        # 
         
    try:                
        # ---------------------------------------------------------------------------------------------
        # INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER CHANNEL 
        # ---------------------------------------------------------------------------------------------
        if ack2put is True:
            message2send4three = "<ack2put4xi>queue2three8shot2three5004xi</ack2put4xi>"
        else:
            message2send4three = "<nack2put4xi>queue2three8shot2three5004xi</nack2put4xi>" 
            
        publisher_channel2three.send(message2send4three)
        if ack2debug is True:    
            print(" (STEP 3B/33) OF FIRE500THREE4XI -  SENT MESSAGE2SEND4THREE: ", message2send4three, " TO PUBLISHER_CHANNEL2THREE: ", publisher_channel2three, " - TIME: ", time4xi()) 
            #  
        
    except:
        print(" (STEP 3C/33) OF FIRE500THREE4XI *** FAILED TO SEND MESSAGE2SEND4THREE: ", message2send4three, " TO PUBLISHER_CHANNEL2THREE: ", publisher_channel2three, " - TIME: ", time4xi()) 
    
    if ack2debug is True:        
        print("\n (STEP 3D/33) OF FIRE500THREE4XI - RETURNING QUEUE OBJECT QUEUE2THREE: ", queue2three, " - TIME: ", time4xi())  
        # 
            
    return queue2three    
        
           
#</function4xi>


#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_verb4xi.txt
#   sense-test-verb4xi.xml
#   reason-test-verb4xi.xml
#   ace-test-verb4xi.xml
#"
#>



# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of fire500three4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
                               
                